//audio
datablock AudioProfile(GrenadeLFireSound)
{
   filename    = "./Grenade_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(GrenadeLExplosionSound)
{
   filename    = "./Grenade_Explosion.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(GrenadeLSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1200;
	lifetimeVarianceMS   = 350;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.1";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 1.55;
   sizes[1]      = 0.3;
	sizes[2]      = 0.0;

   times[0] = 0.0;
   times[1] = 0.38;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GrenadeLSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GrenadeLSmokeParticle";
};


datablock ParticleData(CompactGLExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 2.25;
	sizes[1]      = 2.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(CompactGLExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CompactGLExplosionParticle";

   useEmitterColors = true;
};


datablock ParticleData(CompactGLExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.1 1";
	colors[1]     = "0.9 0.2 0.0 0.1";
	sizes[0]      = 5;
	sizes[1]      = 5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(CompactGLExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CompactGLExplosionRingParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ParticleData(CompactGLExplosionDotsParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 30;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.8 0.3 1";
	colors[1]     = "0.9 0.9 0.9 1";
	sizes[0]      = 0.5;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(CompactGLExplosionDotsEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 0.2;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "CompactGLExplosionDotsParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(CompactGLExplosion)
{
   //explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";
	soundProfile = GrenadeLExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = CompactGLExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = CompactGLExplosionRingEmitter;
   emitter[1] = CompactGLExplosionDotsEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "0.9 0.9 0";
   lightEndColor = "0 0 0";

   damageRadius = 5;
   radiusDamage = 15;

   impulseRadius = 20;
   impulseForce = 2000;
};

AddDamageType("CompactGL",   '<bitmap:add-ons/Weapon_CompactGL/CI_CGrenadeLauncher> %1',    '%2 <bitmap:add-ons/Weapon_CompactGL/CI_CGrenadeLauncher> %1',0.75,1);
datablock ProjectileData(CompactGLProjectile)
{
   projectileShapeName = "./Grenade.dts";
   directDamage        = 45;
   directDamageType    = $DamageType::CompactGL;
   radiusDamageType    = $DamageType::CompactGL;

   brickExplosionRadius = 25;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 25;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 25;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 900;
   verticalImpulse	  = 900;
   explosion           = CompactGLExplosion;
   particleEmitter     = "GrenadeLSmokeEmitter";
	
   explodeOnDeath = true;
   explodeOnPlayerImpact = true; 

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 400;
   lifetime            = 900;
   fadeDelay           = 900;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.05;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.9 0.9 0";
};

function CompactGLProjectile::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
	%type = %col.getType();
	if(((%type & $TypeMasks::PlayerObjectType) || (%type & $TypeMasks::VehicleObjectType)) && minigameCanDamage(%obj,%col) && %obj.numBounces <= 0)
		%obj.explode();
	else
	{
		if(%obj.numBounces < 3)
			serverPlay3D(hammerHitSound,%obj.getTransform());
		%obj.numBounces++;
	}
	
	return Parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}


datablock ProjectileData(CompactGLJumperProjectile)
{
   projectileShapeName = "./Grenade.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::CompactGL;
   radiusDamageType    = $DamageType::CompactGL;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = CompactGLExplosion;
   particleEmitter     = "GrenadeLSmokeEmitter";
	
   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 100;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ItemData(CompactGLItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./GLauncher.2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "C.Grenade Launcher";
	iconName = "./ICON_CGL";
	doColorShift = true;
	colorShiftColor = "0.762 0.766 0.808 1.000";

	 // Dynamic properties defined by the scripts
	image = CompactGLImage;
	canDrop = true;
	
	maxAmmo = 4;
	canReload = 0;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(CompactGLImage)
{
   // Basic Item properties
   shapeFile = "./GLauncher.2.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = CompactGLItem;
   ammo = " ";
   projectile = CompactGLProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.762 0.766 0.808 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]			= "Activate";
	StateSound[0]				= "weaponSwitchSound";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= GrenadeLFireSound;

	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3] 		= "FireLoadCheckA";
	stateTimeoutValue[3]            	= 0.3;
	StateSequence[3]			= "fire";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout

	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";
	
	stateName[6]				= "ReloadWait";
	stateTimeoutValue[6]			= 0.1;
	stateTransitionOnTimeout[6]		= "Reloaded";
	stateScript[6]				= "onReloadWait";
	stateWaitForTimeout[6]			= true;
	
	stateName[7]				= "Reload";
	stateTimeoutValue[7]			= 0.1;
	stateScript[7]				= "onReloadStart";
	stateTransitionOnTimeout[7]		= "ReloadWait";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "Reloaded";
	stateTimeoutValue[8]			= 0.1;
	stateScript[8]				= "onReloaded";
	stateTransitionOnTimeout[8]		= "Ready";

	stateName[9] 				= "Smoke";
	stateEmitter[9]				= gunSmokeEmitter;
	stateEmitterTime[9]			= 0.3;
	stateEmitterNode[9]			= "muzzleNode";
	stateTimeoutValue[9]			= 0.2;
	stateTransitionOnTimeout[9]		= "Ready";
	stateTransitionOnTriggerDown[9]		= "Fire";
	
	stateName[10] 				= "ReloadSmoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Reload";

	stateName[11]				= "FireLoadCheckA";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.01;
	stateTransitionOnTimeout[11]		= "FireLoadCheckB";
	
	stateName[12]				= "FireLoadCheckB";
	stateTransitionOnAmmo[12]		= "Smoke";
	stateTransitionOnNoAmmo[12]		= "ReloadSmoke";
};

function CompactGLImage::onFire(%this,%obj,%slot)
{		
	%projectile = %this.projectile;
	%shellcount = 1;
	%spread = 0;
	%obj.playThread(2, plant);
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function CompactGLImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1); 
}

function CompactGLImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 5;
	%obj.setImageAmmo(%slot,1);
}

function CompactGLImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

package GrenadeJump
{
  	function Armor::onTrigger(%this, %obj, %slot, %val)
	{
		if(%obj.getMountedImage(0) $= CompactGLImage.getID() && %slot $= 4 && %val)
		{
			if(%obj.lastNade !$= "" && getSimTime() - %obj.lastNade < 2000)
			{
				return;
			}
			else
			{
				centerPrint(%client,"<just:right>\c3Your extra grenades haven't charged yet!",3);
			}
			%projectile = CompactGLJumperProjectile;
			%vector = %obj.getMuzzleVector(0);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(0);
				sourceObject = %obj;
				sourceSlot = 0;
				client = %obj.client;
			};
			%obj.lastNade = getSimTime();
			%obj.playThread(2, plant);
			serverPlay3D(GrenadeLFireSound,%obj.getPosition());
			MissionCleanup.add(%p);
			return %p;
		 
		}
		Parent::onTrigger(%this, %obj, %slot, %val);
	}
};	
ActivatePackage(GrenadeJump);	